/*
Program Name: Mortgage.java
File name: Mortgage.java
Programmer: Johnny Warwar
Date: 10/2/18
Version 1.0
Calculates monthly payment of mortgage using objects.
 */

import java.util.Scanner;

public class Mortgage {

    // declaration of variables
    double loan;
    double rate;
    int term;
    double monthlyPayment;
    
    
    // default constructor
    public Mortgage()
    {}

    // constructor with three arguments
    public Mortgage(double la, double rt, int tr)
    {
       // manually set loan, rate, term
       setLoan(la, 100000.0, 2000000.0);
        
       setRate(rt, 0.0);
        
       setTerm(tr, 0);
       
       // function to calcualte monthly payment
       calcMonthlyPayment();
    }
    
    // getter methods for loan, rate, term

    public double getLoan()
    {
        return loan;
    }

    public double getRate()
    {
        return rate;
    }
    
    public int getTerm()
    {
        return term;
    }
    
    // setter methods for loan, rate, term

    public void setLoan(double la)
    {
        loan = la;
    }
    
    // setter method with input validation
    public void setLoan(double la, double lMin, double lMax)
    {
        if ((la < lMin) || (la > lMax))
        {
            System.out.println("Invalid loan amount.");
            System.exit(0);
        }
        else 
        {
            loan = la;
        }
    }

    public void setRate(double rt)
    {
        rate = rt;
    }
    
    public void setRate(double rt, double rMin)
    {
        if (rt < rMin)
        {
            System.out.println("Invalid rate amount.");
            System.exit(0);
        }
        else 
        {
            rate = rt;
        }
    }
    
    public void setTerm(int tr)
    {
        term = tr;
    }
    
    public void setTerm(int tr, double tMin)
    {
        if (tr < tMin)
        {
            System.out.println("Invalid term amount.");
            System.exit(0);
        }
        else 
        {
            term = tr;
        }
    }

    // method to calculate monthly payment
    public void calcMonthlyPayment()
    {
        
        rate = (rate)/100.0;

	rate = (rate)/12.0;

	term = term * 12;
        
        monthlyPayment = (loan * rate)/(1.0-Math.pow(rate+1.0, -term));
        
    }

    // method to display the results
    public void display()
    {
        System.out.printf("************************************\n");
        System.out.printf("The monthly payment is: $%.2f\n", monthlyPayment);
        System.out.printf("************************************\n");
        System.out.printf("\n");
    }

}