/*
Program Name: Rectangle.java
Programmer: Johnny Warwar
Date: 9/26/18
Calculates the area and perimeter of a rectangle using objects.
 */


public class Rectangle {
  private double width;
  double length;
  double area;
  double perimeter;


  public Rectangle() {
  }

  public Rectangle(double wid, double len) {
    width = wid;
    length = len;
    calcArea();
    calcPerimeter();
  }

  public double getWidth() {
    return width;
  }

  public double getLength() {
      return length;
  }

  public void setWidth(double wid) {
    width = wid;
  }

  public void setLength(double len) {
    length = len;
  }

// method to calculate area
public void calcArea()
{
    area = width * length;
}

// method to calculate perimeter
public void calcPerimeter()
{
    perimeter = 2.0 * (width + length);
}

// method to display the results
public void display()
{
    System.out.printf("*************************************\n");
    System.out.printf("Rectangle Geom  : (%.2f x %.2f)\n", width, length);
    System.out.printf("The area is     : %.2f%n", area);
    System.out.printf("The perimeter is: %.2f%n", perimeter);
    System.out.printf("*************************************\n");
    System.out.printf("\n");

}

public static void main (String [] args)
{


    // create a new rectangle object
    Rectangle rec1 = new Rectangle();

    // manually set the length and width
    rec1.setWidth(20.5);
    rec1.setLength(5.2);

    // calculate area and perimeter
    rec1.calcArea();
    rec1.calcPerimeter();

    // display rectange after calculating
    rec1.display();
    
    rec1.width = 1.0;
    // calculate area and perimeter
    rec1.calcArea();
    rec1.calcPerimeter();

    // display rectange after calculating
    rec1.display();
    

    // create another rectangle using second version constructor
    Rectangle rec2 = new Rectangle(5.7, 15.8);

    // display rectange after calculating
    rec2.display();

}   // end main

}
